@page "/products"
@using Shop.StoreFront.Models
@using Newtonsoft.Json

@inject HttpClient HttpClient

@if (_isLoading)
{
    <h2>Loading products...</h2>
}
else
{
    @for (int i = 0; i < _products.Length; i+=_cols)
    {
        <div class="row">
            @for (int j = 0; j < _cols; j++)
            {
                if (i + j >= _products.Length)
                {
                    break;
                }
                
                <div class="col-md-3 p-2">
                    <div class="card" style="width: 18rem;">
                        <img class="card-img-top" src="..." alt="Card image cap">
                        <div class="card-body">
                            <h5 class="card-title">@_products[i + j].Title</h5>
                            <p class="card-text">@_products[i + j].Description</p>
                        </div>
                        <ul class="list-group list-group-flush">
                            <li class="list-group-item">Price: @_products[i + j].Price</li>
                        </ul>
                        <div class="card-footer">
                            <div class="row">
                                <div class="col-sm-6">
                                    <NavLink href="@($"product/{_products[i + j].Id}")" class="btn btn-warning">Details</NavLink>
                                </div>
                                <div class="col-sm-6">
                                    <a href="#" class="btn btn-outline-success">Add to Cart</a>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            }
        </div>
    }
    
    <nav aria-label="...">
      <ul class="pagination">
          <li class="page-item @((_canPaginate == false ? "disabled" : ""))">
              <span class="page-link" @onclick="PrevAsync">Previous</span>
          </li>
          <li class="page-item">
              <span class="page-link" @onclick="NextAsync">Next</span>
          </li>
      </ul>
    </nav>
}


@code
{
    private bool _isLoading = true;

    private int _pageSize = 10;
    private int _pageNumber = 1;
    
    private Product[] _products;

    private int _cols = 4;

    private bool _pagingEnabled;
    private bool _canPaginate = false;
    
    protected override async Task OnInitializedAsync()
    {
        await LoadDataAsync();

        _isLoading = false;
    }

    private async Task LoadDataAsync()
    {
        var response = await HttpClient
            .GetAsync($"https://localhost:5001/api/Product/Paginated?pageNumber={_pageNumber}&pageSize={_pageSize}");

        if (response.IsSuccessStatusCode)
        {
            var responseString = await response.Content.ReadAsStringAsync();
            _products = JsonConvert.DeserializeObject<Product[]>(responseString);

        }
    }

    public async Task NextAsync()
    {
        _pageNumber++;
        await LoadDataAsync();
        _canPaginate = true;
    }

    public async Task PrevAsync()
    {
        _pageNumber--;
        await LoadDataAsync();
        
        if (_pageNumber == 1)
            _canPaginate = false;
    }
}
